#!/bin/sh

if [ -z "$1" ]; then
  echo
  echo "usage: run.sh /dev/sdX [pocketgo|trimui|fc3000]|[fc3000_ips1]|[fc3000_tft]|[fc3000_ips2]"
  echo "fc3000_ips1 = RB411-11A         ->  V? IPS"
  echo "fc3000_ips2 = WL-28H105-A1      ->  V2 IPS"
  echo "fc3000_tft = T2812-M106-24C-7D  ->  V1 TFT (old version)"
  echo
  exit
fi

if [ -z "$2" ]; then
  echo
  echo "usage: run.sh /dev/sdX [pocketgo|trimui|fc3000]|[fc3000_ips1]|[fc3000_tft]|[fc3000_ips2]"
  echo "fc3000_ips1 = RB411-11A         ->  V? IPS"
  echo "fc3000_ips2 = WL-28H105-A1      ->  V2 IPS"
  echo "fc3000_tft = T2812-M106-24C-7D  ->  V1 TFT (old version)"
  echo
  exit
fi


./mkimage -C none -A arm -T script -d param.cmd param.scr &&
./bin2header param.scr hex_boot > fs/hex_boot.h &&
./bin2header ../kernel/arch/arm/boot/zImage hex_kernel > fs/hex_kernel.h &&
./bin2header ../kernel/arch/arm/boot/dts/$2.dtb hex_dtb > fs/hex_dtb.h &&
ARCH=arm CROSS_COMPILE=arm-linux- make -j &&
sudo dd if=u-boot-sunxi-with-spl.bin of=$1 bs=1024 seek=8 conv=notrunc && 
sync
